var bPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var popupOn = false;

function deleteClose() {
    MsgDeleteMessageFromMessageWindow(false,true);
    window.close();
}

function forwardClose() {
    MsgForwardMessage(null);
    window.close();
}

function replyClose() {
    MsgReplyMessage(null);
    window.close();
}

function replyAllClose() {
    MsgReplyToAllMessage(null);
    window.close();
}

function realNextMessageWindow() {
    performNavigation(nsMsgNavigationType.nextMessage);
}

function realPreviousMessageWindow() {
    performNavigation(nsMsgNavigationType.previousMessage);
}

function realNextMessage() {
    GoNextMessage(nsMsgNavigationType.nextMessage, false );
}

function realPreviousMessage() {
    GoNextMessage(nsMsgNavigationType.previousMessage, false );
}

function openSMTPSelect() {
    if (popupOn)
        return;

    var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
    var e = watcher.getWindowByName("smtp", null);

    if (e) {
        e.focus();
    } else {
        var args = {result: false};
        window.openDialog('chrome://messenger/content/SmtpServerList.xul', 'smtp', 'modal,titlebar,chrome', args);
    }
}

// Thanks to Torisugari for this function!
function isInChromeAndEnabled(aResourceURI)
{
   try{
      var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
               .getService(Components.interfaces.nsIRDFService);
      var Container = Components.classes["@mozilla.org/rdf/container;1"]
               .getService(Components.interfaces.nsIRDFContainer);

      var chromeDS=RDFService.GetDataSource("rdf:chrome");
      var cResource=RDFService.GetResource("urn:mozilla:package:root");
      var disabledArc=RDFService
               .GetResource("http://www.mozilla.org/rdf/chrome#disabled");

      var target=RDFService.GetResource(aResourceURI);
      Container.Init(chromeDS,cResource);

      return (Container.IndexOf(target) > -1) &&
            !chromeDS.hasArcOut(target,disabledArc);
   }catch(e) {}
   return false;
}

function bSMTPDropInit(ssunInstalled) {
    var p = document.getElementById("SelectSMTP");
    var e = p.getElementsByTagName("menuitem");
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
    var servers = smtpService.smtpServers;
    var defaultSMTP = smtpService.defaultServer;
    var serverCount = servers.Count();
    var ssunInstalled = isInChromeAndEnabled("urn:mozilla:package:ssun");

    var showUsername = false;
    var useAlias = false;
    var hideUsername = true;

    if (ssunInstalled) {
        useAlias = true;
        showUsername = true;
        hideUsername = true;
        try { useAlias = bPrefs.getBoolPref("ssun.showalias"); } catch (ex) {}
        try { showUsername = bPrefs.getBoolPref("ssun.showusername"); } catch (ex) {}
        try { hideUsername = bPrefs.getBoolPref("ssun.hideusername"); } catch (ex) {}
    }

    for (var i = 0; i < serverCount; ++i) {
        var server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
        var myKey = server.key;
        for (var j = 0; j < e.length; ++j) {
            if (myKey == e[j].value) {
                var hostname = server.hostname;
                var port = "";

                if (server.port)
                    port = ":" + server.port;

                var alias = "";
                if (useAlias) {
                    try { alias = bPrefs.getCharPref("ssun." + server.key + ".alias"); } catch (ex) {}
                    if (alias) {
                        hostname = alias;
                    } else {
                        hostname += port;
                    }
                } else {
                    hostname += port;
                }

                if (showUsername && (!useAlias || (useAlias && (!alias || !hideUsername))) && server.authMethod && server.username)
                    hostname += " (" + server.username + ")";

                e[j].label = hostname;

                if (myKey == defaultSMTP.key)
                    e[j].setAttribute("checked", true);

                break;
            }
        }
    }
}

function bSMTPSelectDefault(p) {
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
    if (p.value != smtpService.defaultServer.key) {
        smtpService.defaultServer = smtpService.getServerByKey(p.value);
    }
    popupOn = true;
}

function buttonsDeleteJunk() {
    var enabled = new Object();
    enabled.value = false;
    var checkStatus = new Object();
    if (gDBView)
        gDBView.getCommandStatus(nsMsgViewCommandType.deleteJunk, enabled, checkStatus);

    // Run command if valid
    if (enabled.value) {
        var bypassTrash = 0;

        try	{
            if (!bPrefs)
                bGetPrefs();
        } catch (ex) {}

        try { bypassTrash = bPrefs.getIntPref("buttons.bypasstrash"); } catch (ex) {}

        if (bypassTrash == 1) {
            var folderTree = GetFolderTree();
            var folderResource = GetFolderResource(folderTree, GetSelectedFolderIndex());
            var specialFolder = GetFolderAttribute(folderTree, folderResource, "SpecialFolder");

            if (specialFolder != "Junk")
                bypassTrash = 0;
        }

        if (bypassTrash == 0) {
            // Delete junk into Trash
            deleteJunkInFolder();
        } else {
            // Delete junk bypassing Trash
            /* Copied from deleteJunkInFolder() in mailCommands.js
               Changed if statements so we don't return out of function
            */
            MsgJunkMailInfo(true);
            var view = GetDBView();

            // need to expand all threads, so we find everything
            view.doCommand(nsMsgViewCommandType.expandAll);

            var treeView = view.QueryInterface(Components.interfaces.nsITreeView);
            var count = treeView.rowCount;
            if (count) {
                var treeSelection = treeView.selection;

                var clearedSelection = false;

                // select the junk messages
                for (var i = 0; i < count; i++) {
                    var messageUri = view.getURIForViewIndex(i);
                    var msgHdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);
                    var junkScore = msgHdr.getStringProperty("junkscore");
                    var isJunk = ((junkScore != "") && (junkScore != "0"));
                    // if the message is junk, select it.
                    if (isJunk) {
                      // only do this once
                      if (!clearedSelection) {
                        // clear the current selection
                        // since we will be deleting all selected messages
                        treeSelection.clearSelection();
                        clearedSelection = true;
                        treeSelection.selectEventsSuppressed = true;
                      }
                      treeSelection.rangedSelect(i, i, true /* augment */);
                    }
                }

                // if we didn't clear the selection
                // there was no junk, so bail.
                if (clearedSelection) {
                    treeSelection.selectEventsSuppressed = false;
                    // delete the selected messages
                    //
                    // XXX todo
                    // should we try to set next message after delete
                    // to the message selected before we did all this, if it was not junk?
                    SetNextMessageAfterDelete();
                    view.doCommand(nsMsgViewCommandType.deleteNoTrash);
                    treeSelection.clearSelection();
                }
            }
        }
    }
}

function bToggleHTML() {
    var html_as = 0;
    var prefer_plaintext = false;
    var disallow_classes = 0;
    try
    {
        prefer_plaintext = bPrefs.getBoolPref("mailnews.display.prefer_plaintext");
        html_as = bPrefs.getIntPref("mailnews.display.html_as");
        disallow_classes = bPrefs.getIntPref("mailnews.display.disallow_mime_handlers");
        if (disallow_classes > 0)
            disallow_classes_no_html = disallow_classes;
            // else disallow_classes_no_html keeps its inital value (see top)
    }
    catch (ex)
    {
        dump("failed to get the body plaintext vs. HTML prefs\n");
    }

    var AllowHTML_checked = false;
    var Sanitized_checked = false;
    var AsPlaintext_checked = false;
    if (!prefer_plaintext && !html_as && !disallow_classes)
        AllowHTML_checked = true;
    else if (!prefer_plaintext && html_as == 3 && disallow_classes > 0)
        Sanitized_checked = true;
    else if (prefer_plaintext && html_as == 1 && disallow_classes > 0)
        AsPlaintext_checked = true;

    var htmlSwitch = 0;
    try { htmlSwitch = bPrefs.getIntPref("buttons.htmlswitch"); } catch (ex) {}
    switch (htmlSwitch) {
        case 0:
            if (AsPlaintext_checked)
                MsgBodyAllowHTML();
            else
                MsgBodyAsPlaintext();
            break;
        case 1:
            if (AsPlaintext_checked)
                MsgBodySanitized();
            else
                MsgBodyAsPlaintext();
            break;
        case 2:
            if (Sanitized_checked)
                MsgBodyAllowHTML();
            else
                MsgBodySanitized();
            break;
        default:
            break;
    }
}

function bToggleImages() {
    var showImages = false;
    try { showImages = bPrefs.getBoolPref("mailnews.message_display.disable_remote_image"); } catch (ex) { return; }
    try { bPrefs.setBoolPref("mailnews.message_display.disable_remote_image", !showImages); } catch (ex) {}
    MsgReload();
}